package com.xingye.atswingtool.controller;

import com.google.gson.Gson;

import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.swing.*;
import javax.swing.text.JTextComponent;
import java.awt.*;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

public class CsExperimentController extends HttpServlet {

    protected void doGet(HttpServletRequest request, HttpServletResponse response) {
        try {

            Window[] windows = Window.getWindows();
            List<Map<String, String>> result = new ArrayList<>();
            for (Window window : windows) {
                if (window instanceof JFrame) {
                    Component[] components = ((JFrame) window).getContentPane().getComponents();
                    Map<String, String> oneRecord = new HashMap<>();
                    oneRecord.put("frame", "true");
                    oneRecord.put("title", ((JFrame) window).getTitle());
                    oneRecord.put("height", Integer.toString(((JFrame) window).getHeight()));
                    oneRecord.put("width", Integer.toString(((JFrame) window).getWidth()));
                    oneRecord.put("clazz", ((JFrame) window).getClass().getName());
                    result.add(oneRecord);
                    for (Component component : components) {
                        recursion(component, result);
                    }
                } else if (window instanceof JDialog) {
                    Component[] components = ((JDialog) window).getContentPane().getComponents();
                    Map<String, String> oneRecord = new HashMap<>();
                    oneRecord.put("dialog", "true");
                    oneRecord.put("title", ((JDialog) window).getTitle());
                    oneRecord.put("height", Integer.toString(((JDialog) window).getHeight()));
                    oneRecord.put("width", Integer.toString(((JDialog) window).getWidth()));
                    oneRecord.put("clazz", ((JDialog) window).getClass().getName());
                    result.add(oneRecord);
                    for (Component component : components) {
                        recursion(component, result);
                    }
                }
            }
            Gson gson = new Gson();
            System.out.println(gson.toJson(result));
            response.getWriter().println(gson.toJson(result));
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    private void recursion(Component component, List<Map<String, String>> result) {
        if (component instanceof JPanel) {
            Component[] components = ((JPanel) component).getComponents();
            for (Component comp : components) {
                recursion(comp, result);
            }
            return;
        } else if (component instanceof JScrollPane) {
            Component[] components = ((JScrollPane) component).getComponents();
            for (Component comp : components) {
                recursion(comp, result);
            }
            return;
        } else if (component instanceof JTabbedPane) {
            Component[] components = ((JTabbedPane) component).getComponents();
            for (Component comp : components) {
                recursion(comp, result);
            }
            return;
        }
        Map<String, String> oneRecord = new HashMap<>();
        String name = component.getName();
        Integer height = component.getHeight();
        Integer width = component.getWidth();
        Point p = component.getLocation();
        Double x = p.getX();
        Double y = p.getY();


        Class clazz = component.getClass();
        oneRecord.put("clazz", clazz.getName());
        oneRecord.put("name", name);
        oneRecord.put("height", height.toString());
        oneRecord.put("width", width.toString());
        oneRecord.put("x", x.toString());
        oneRecord.put("y", y.toString());
        oneRecord.put("visible", Boolean.toString(component.isVisible()));
        oneRecord.put("focusable", Boolean.toString(component.isFocusable()));
        oneRecord.put("displayable", Boolean.toString(component.isDisplayable()));
        oneRecord.put("isshowing", Boolean.toString(component.isShowing()));


        if (component instanceof JButton) {
            oneRecord.put("text", ((JButton) component).getText());
        } else if (component instanceof JTextComponent) {
            oneRecord.put("text", ((JTextComponent) component).getText());
        } else if (component instanceof JLabel) {
            oneRecord.put("text", ((JLabel) component).getText());
        } else if (component instanceof ItemSelectable) {
            StringBuffer stringBuffer = new StringBuffer();
            for (Object item : ((ItemSelectable) component).getSelectedObjects()) {
                stringBuffer.append(item);
                stringBuffer.append(",");
            }
            oneRecord.put("text", stringBuffer.toString());
        }
        result.add(oneRecord);

    }


}